Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Code gnr par le Concepteur Windows Form "

    Public Sub New()
        MyBase.New()

        'Cet appel est requis par le Concepteur Windows Form.
        InitializeComponent()

        'Ajoutez une initialisation quelconque aprs l'appel InitializeComponent()

    End Sub

    'La mthode substitue Dispose du formulaire pour nettoyer la liste des composants.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Requis par le Concepteur Windows Form
    Private components As System.ComponentModel.IContainer

    'REMARQUE: la procdure suivante est requise par le Concepteur Windows Form
    'Elle peut tre modifie en utilisant le Concepteur Windows Form.  
    'Ne la modifiez pas en utilisant l'diteur de code.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents TextBox2 As System.Windows.Forms.TextBox
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents Button1 As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(Form1))
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.TextBox2 = New System.Windows.Forms.TextBox
        Me.Button1 = New System.Windows.Forms.Button
        Me.TextBox1 = New System.Windows.Forms.TextBox
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(32, 24)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(168, 16)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "Nombre de lignes (de 1  10)"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(32, 58)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(168, 16)
        Me.Label2.TabIndex = 3
        Me.Label2.Text = "Nombre de colonnes (de 1  10)"
        '
        'TextBox2
        '
        Me.TextBox2.Location = New System.Drawing.Point(208, 56)
        Me.TextBox2.Name = "TextBox2"
        Me.TextBox2.Size = New System.Drawing.Size(40, 20)
        Me.TextBox2.TabIndex = 2
        '
        'Button1
        '
        Me.Button1.Location = New System.Drawing.Point(272, 22)
        Me.Button1.Name = "Button1"
        Me.Button1.Size = New System.Drawing.Size(176, 56)
        Me.Button1.TabIndex = 4
        Me.Button1.Text = "Gnrer le damier"
        '
        'TextBox1
        '
        Me.TextBox1.Location = New System.Drawing.Point(208, 22)
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(40, 20)
        Me.TextBox1.TabIndex = 0
        '
        'Panel1
        '
        Me.Panel1.Location = New System.Drawing.Point(35, 103)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(413, 427)
        Me.Panel1.TabIndex = 5
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(480, 542)
        Me.Controls.Add(Me.Panel1)
        Me.Controls.Add(Me.Button1)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.TextBox2)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.TextBox1)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "Form1"
        Me.Text = "Damier sur mesure"
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Dim nblignes, nbcolonnes As Byte

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' on rcupre les valeurs entres
        nblignes = Val(TextBox1.Text)
        nbcolonnes = Val(TextBox2.Text)

        ' on vrifie que les donnes entres sont correctes
        Dim toto As Integer
        If nblignes < 1 Or nblignes > 10 Then
            toto = MsgBox("Nombre de lignes incorrect", vbExclamation, "Gnration impossible")
        End If
        If nbcolonnes < 1 Or nbcolonnes > 10 Then
            toto = MsgBox("Nombre de colonnes incorrect", vbExclamation, "Gnration impossible")
        End If

        'on supprime tous les membres prcdents de la collection Mescases
        Dim i As Integer
        For i = 0 To Panel1.Controls.Count - 1
            Panel1.Controls(0).Dispose()
        Next i

        ' on cre une nouvelle srie de contrles, en les disposant convenablement
        For i = 0 To nblignes * nbcolonnes - 1
            Dim b As New Button
            b.Name = "Bouton" & i
            Panel1.Controls.Add(b)
            AddHandler b.Click, AddressOf Damierclick
            b.Height = 40
            b.Width = 40
            b.Left = 40 * (i Mod nbcolonnes)
            b.Top = 40 * (i \ nbcolonnes)
        Next i
    End Sub

    Private Sub Damierclick(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ' on efface tous les boutons
        Dim i, ind As Integer
        For i = 0 To Panel1.Controls.Count - 1
            Panel1.Controls(i).Text = ""
        Next i

        ' on pose le texte sur le bouton cliqu
        sender.text = "X"

        ' on identifie l'index de la case clique
        ind = Panel1.Controls.IndexOf(sender)

        ' on reconstitue les lignes et les colonnes d'aprs ind
        Dim lig, col As Integer
        lig = Int((ind) / nbcolonnes) + 1
        col = ((ind) Mod nbcolonnes) + 1
        Me.Text = "case n" & ind + 1 & " - Ligne " & lig & " , colonne " & col

    End Sub
End Class
